// source: https://www.baeldung.com/java-bubble-sort

import java.util.Random;

public class BubbleSort {
    public static int[] getData(int size) {
        Random random = new Random(0xdeadbeaf);
        int[] data = new int[size];
        for (int i = 0; i < data.length; i++) {
            data[i] = random.nextInt();
        }
        return data;
    }

    public static void bubbleSort(int[] arr) {
        int i = 0, n = arr.length;
        boolean swapNeeded = true;
        while (i < n - 1 && swapNeeded) {
            swapNeeded = false;
            for (int j = 1; j < n - i; j++) {
                if (arr[j - 1] > arr[j]) {
                    int temp = arr[j - 1];
                    arr[j - 1] = arr[j];
                    arr[j] = temp;
                    swapNeeded = true;
                }
            }
            if(!swapNeeded) {
                break;
            }
            i++;
        }
    }

    public static void main(String[] args) {
        int[] input = getData(Integer.parseInt(args[0]));
        long start = System.nanoTime();
        bubbleSort(input);
        long duration = System.nanoTime() - start;
        System.out.println(duration);
    }
}