// source: https://www.baeldung.com/java-merge-sort

import java.util.Random;

public class MergeSort {
    public static int[] getData(int size) {
        Random random = new Random(0xdeadbeaf);
        int[] data = new int[size];
        for (int i = 0; i < data.length; i++) {
            data[i] = random.nextInt();
        }
        return data;
    }

    public static void merge(
            int[] a, int[] l, int[] r, int left, int right) {

        int i = 0, j = 0, k = 0;
        while (i < left && j < right) {
            if (l[i] <= r[j]) {
                a[k++] = l[i++];
            }
            else {
                a[k++] = r[j++];
            }
        }
        while (i < left) {
            a[k++] = l[i++];
        }
        while (j < right) {
            a[k++] = r[j++];
        }
    }

    public static void mergeSort(int[] a, int n) {
        if (n < 2) {
            return;
        }
        int mid = n / 2;
        int[] l = new int[mid];
        int[] r = new int[n - mid];
        System.arraycopy(a, 0, l, 0, mid);
        System.arraycopy(a, mid, r, 0, n - mid);
        mergeSort(l, mid);
        mergeSort(r, n - mid);
        merge(a, l, r, mid, n - mid);
    }

    public static void main(String[] args) {
        int[] input = getData(Integer.parseInt(args[0]));
        long start = System.nanoTime();
        mergeSort(input, input.length);
        long duration = System.nanoTime() - start;
        System.out.println(duration);
    }
}