// source: https://www.baeldung.com/java-quicksort

import java.util.Random;

public class QuickSort {
    public static int[] getData(int size) {
        Random random = new Random(0xdeadbeaf);
        int[] data = new int[size];
        for (int i = 0; i < data.length; i++) {
            data[i] = random.nextInt();
        }
        return data;
    }

    private static int partition(int arr[], int begin, int end) {
        int pivot = arr[end];
        int i = (begin - 1);

        for (int j = begin; j < end; j++) {
            if (arr[j] <= pivot) {
                i++;

                int swapTemp = arr[i];
                arr[i] = arr[j];
                arr[j] = swapTemp;
            }
        }

        int swapTemp = arr[i + 1];
        arr[i + 1] = arr[end];
        arr[end] = swapTemp;

        return i + 1;
    }

    public static void quickSort(int arr[], int begin, int end) {
        if (begin < end) {
            int partitionIndex = partition(arr, begin, end);
            quickSort(arr, begin, partitionIndex - 1);
            quickSort(arr, partitionIndex + 1, end);
        }
    }

    public static void main(String[] args) {
        int[] input = getData(Integer.parseInt(args[0]));
        long start = System.nanoTime();
        quickSort(input, 0, input.length - 1);
        long duration = System.nanoTime() - start;
        System.out.println(duration);
    }
}