package de.marstra.dvo.obfuscator;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonPOJOBuilder;
import de.marstra.dvo.obfuscator.util.GenericMethodReference;
import lombok.Builder;
import lombok.Data;
import lombok.RequiredArgsConstructor;

import java.io.File;
import java.io.IOException;
import java.util.Set;

@Data
@RequiredArgsConstructor
@Builder
@JsonDeserialize(builder = Config.ConfigBuilder.class)
public class Config {
    private final Set<GenericMethodReference> methodsToObfuscate;
    private final Set<InterpreterGenerator.VerbosityLevel> interpreterVerbosityLevels;
    private final boolean signDebug;
    private final boolean protect;
    private final boolean debugProtection;
    private final boolean renameInterpreter;

    public static Config fromFile(File configFile) {
        ObjectMapper mapper = new ObjectMapper();
        try {
            return mapper.readValue(configFile, Config.class);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    @JsonPOJOBuilder(withPrefix = "")
    public static class ConfigBuilder {
    }
}
