package de.marstra.dvo.obfuscator.analysis;

public abstract class AnalysisVisitorAdapter<RetType, Param> implements AnalysisVisitor<RetType, Param> {
    protected RetType aggregatePackage(DexPackage dexPackage, RetType prev, RetType next) {
        return null;
    }

    public RetType visit(DexPackage dexPackage, Param p) {
        RetType ret = null;
        for (DexPackageItem m : dexPackage.getChildren()) {
            ret = aggregatePackage(dexPackage, ret, m.accept(this, p));
        }
        return ret;
    }

    protected RetType aggregateClass(DexClass dexClass, RetType prev, RetType next) {
        return null;
    }

    public RetType visit(DexClass dexClass, Param p) {
        RetType ret = null;
        for (DexMethod m : dexClass.getMethods()) {
            ret = aggregateClass(dexClass, ret, m.accept(this, p));
        }
        return ret;
    }

    public RetType visit(DexMethod dexMethod, Param p) {
        return null;
    }
}
