package de.marstra.dvo.obfuscator.insn;

import com.squareup.javapoet.CodeBlock;
import de.marstra.dvo.obfuscator.VMODexCompiler;

import java.lang.reflect.Array;

import static de.marstra.dvo.obfuscator.insn.InstructionType.ARRAY_LENGTH;

public class ArrayLength extends Instruction {
    private final int dst;
    private final int array;

    public ArrayLength(int dst, int array) {
        super(ARRAY_LENGTH, ARRAY_LENGTH);
        this.dst = dst;
        this.array = array;
    }

    @Override
    byte[] serializeBody(VMODexCompiler.MethodBuilder methodBuilder) {
        return new byte[]{((byte) ((dst & 0xF) | ((array << 4) & 0xF0)))};
    }

    public static void generateCase(CodeBlock.Builder builder, InstructionType type) {
        builder.addStatement("regs[$L] = new InterpreterNumber($T.getLength(regs[$L]))", readLowNibble(), Array.class, readHighNibble())
                .addStatement("break");
    }
}
