package de.marstra.dvo.obfuscator.insn;

import com.squareup.javapoet.CodeBlock;
import de.marstra.dvo.obfuscator.VMODexCompiler;

import java.nio.ByteBuffer;

import static de.marstra.dvo.obfuscator.insn.InstructionType.NEW_INSTANCE;

public class NewInstance extends Instruction {
    private final int dst;
    private final String type;

    public NewInstance(int dst, String type) {
        super(NEW_INSTANCE, NEW_INSTANCE);
        this.dst = dst;
        this.type = type;
    }

    @Override
    byte[] serializeBody(VMODexCompiler.MethodBuilder methodBuilder) {
        return ByteBuffer.allocate(3).put((byte) dst)
                .putShort((short) methodBuilder.getVmoDexBuilder().addTypeReference(type))
                .array();
    }

    public static void generateCase(CodeBlock.Builder builder, InstructionType type) {
        builder.addStatement("int regNum = $L", readUnsignedByte())
                .addStatement("regs[regNum] = new UninitializedInstance(Utils.loadClassByName(vmoDex.types[$L], classLoader), regNum)", readUnsignedShort())
                .addStatement("break");

    }
}
