package de.marstra.dvo.obfuscator.insn;

import de.marstra.dvo.obfuscator.VMODexCompiler;

import java.nio.ByteBuffer;

public abstract class OffsetInstruction extends Instruction {
    private int codeOffset;

    protected OffsetInstruction(int codeOffset, InstructionType instructionType, InstructionType... allowedTypes) {
        super(instructionType, allowedTypes);
        this.codeOffset = codeOffset;
    }

    byte[] serializeBody(VMODexCompiler.MethodBuilder methodBuilder) {
        int actualOffset = methodBuilder.translateCodeOffset(this, codeOffset);
        return ByteBuffer.allocate(4).putInt(actualOffset).array();
    }
}
