package de.marstra.dvo.obfuscator.insn;

import com.squareup.javapoet.CodeBlock;
import de.marstra.dvo.obfuscator.VMODexCompiler;

import static de.marstra.dvo.obfuscator.insn.InstructionType.THROW;

public class Throw extends Instruction {
    private final int reg;

    public Throw(int reg) {
        super(THROW, THROW);
        this.reg = reg;
    }

    @Override
    byte[] serializeBody(VMODexCompiler.MethodBuilder methodBuilder) {
        return new byte[]{(byte) reg};
    }

    public static void generateCase(CodeBlock.Builder builder, InstructionType type) {
        builder.addStatement("throw (Throwable) regs[$L]", readUnsignedByte());
    }
}
