package de.marstra.dvo.obfuscator.insn;

import com.squareup.javapoet.CodeBlock;
import de.marstra.dvo.obfuscator.VMODexCompiler;

import static de.marstra.dvo.obfuscator.insn.InstructionType.*;

public class UnOp extends Instruction {
    private final int target;
    private final int source;

    public UnOp(InstructionType instructionType, int target, int source) {
        super(instructionType, NEG_INT, NOT_INT, NEG_LONG, NOT_LONG, NEG_FLOAT, NEG_DOUBLE, INT_TO_LONG, INT_TO_FLOAT, INT_TO_DOUBLE, LONG_TO_INT, LONG_TO_FLOAT, LONG_TO_DOUBLE, FLOAT_TO_INT, FLOAT_TO_LONG, FLOAT_TO_DOUBLE, DOUBLE_TO_INT, DOUBLE_TO_LONG, DOUBLE_TO_FLOAT, INT_TO_BYTE, INT_TO_CHAR, INT_TO_SHORT);
        this.target = target;
        this.source = source;
    }

    @Override
    byte[] serializeBody(VMODexCompiler.MethodBuilder methodBuilder) {
        return new byte[]{(byte) target, (byte) source};
    }

    public static void generateCase(CodeBlock.Builder builder, InstructionType type) {
        String operation = (String) type.getGenerateArgs()[0];
        String statement = "regs[$L] = new InterpreterNumber(" + operation.replace("$val", "((InterpreterNumber) regs[$L])") + ")";
        builder.addStatement(statement, readUnsignedByte(), readUnsignedByte())
                .addStatement("break");
    }
}

