package interpreter;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.nio.ByteBuffer;

public final class ExceptionHandler {
    public final int address;
    public final String exceptionType;

    public ExceptionHandler(int address, String exceptionType) {
        this.address = address;
        this.exceptionType = exceptionType;
    }

    public static ExceptionHandler deserialize(ByteBuffer buf) {
        int address = buf.getInt();
        String exceptionType = Utils.deserializeString(buf);
        return new ExceptionHandler(address, exceptionType);
    }

    public byte[] serialize() {
        ByteArrayOutputStream baout = new ByteArrayOutputStream();
        try {
            baout.write(Utils.intToBytes(address));
            Utils.serializeString(baout, exceptionType);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        return baout.toByteArray();
    }
}
