package interpreter;

import java.util.LinkedList;
import java.util.List;

public final class UninitializedInstance {
    public final Class clazz;
    public final List<Integer> references;

    public UninitializedInstance(Class clazz, int reg) {
        this.clazz = clazz;
        this.references = new LinkedList<Integer>();
        this.addReference(reg);
    }

    public void addReference(int regId) {
        references.add(regId);
    }

    public void init(Object[] regs, Object instance) {
        for (int ref : references)
            if (regs[ref] == this) regs[ref] = instance;
    }
}
