package interpreter;

import org.junit.Test;

import static org.junit.Assert.assertEquals;

public class UtilsTest {

    @Test
    public void typeConversion() {
        String type = "Z";
        Object orig = false;
        Object conv = Utils.vmTypeToExternalType(type, Utils.externalTypeToVmType(type, orig));
        assertEquals(orig, conv);

        type = "C";
        orig = 'A';
        conv = Utils.vmTypeToExternalType(type, Utils.externalTypeToVmType(type, orig));
        assertEquals(orig, conv);

        type = "B";
        orig = (byte) 0x42;
        conv = Utils.vmTypeToExternalType(type, Utils.externalTypeToVmType(type, orig));
        assertEquals(orig, conv);

        type = "S";
        orig = Short.MAX_VALUE;
        conv = Utils.vmTypeToExternalType(type, Utils.externalTypeToVmType(type, orig));
        assertEquals(orig, conv);

        type = "I";
        orig = Integer.MAX_VALUE;
        conv = Utils.vmTypeToExternalType(type, Utils.externalTypeToVmType(type, orig));
        assertEquals(orig, conv);

        type = "F";
        orig = Float.MAX_VALUE;
        conv = Utils.vmTypeToExternalType(type, Utils.externalTypeToVmType(type, orig));
        assertEquals(orig, conv);

        type = "D";
        orig = Double.MAX_VALUE;
        conv = Utils.vmTypeToExternalType(type, Utils.externalTypeToVmType(type, orig));
        assertEquals(orig, conv);

        type = "J";
        orig = Long.MAX_VALUE;
        conv = Utils.vmTypeToExternalType(type, Utils.externalTypeToVmType(type, orig));
        assertEquals(orig, conv);
    }
}