#!/usr/bin/env python
import argparse
import subprocess
import sys

ADB_EXECUTABLE = "adb"

REMOTE_DIR = "/data/local/tmp"

CLI_ARGS = None

def call(args):
    return subprocess.check_output(args, shell=True)

def main():
    call(ADB_EXECUTABLE +  " push " + CLI_ARGS.dexfile + " " + REMOTE_DIR)
    output = call(ADB_EXECUTABLE +  " shell dalvikvm -cp " + REMOTE_DIR + "/" + CLI_ARGS.dexfile + " " + CLI_ARGS.start_class)
    sys.stdout.write(output)

if __name__ == "__main__":
    parser = argparse.ArgumentParser(description="Run Dalvik Bytecode in emulator")
    parser.add_argument("dexfile", help="Dex-File containing code")
    parser.add_argument("start_class", help="Class which contains main method")
    CLI_ARGS = parser.parse_args()
    main()
