package de.marstra.dvo.webservice;

import org.eclipse.jetty.server.Server;
import org.eclipse.jetty.servlet.DefaultServlet;
import org.eclipse.jetty.servlet.ServletContextHandler;
import org.eclipse.jetty.servlet.ServletHolder;
import org.glassfish.jersey.servlet.ServletContainer;


public class Main {
    public static void main(String[] args) {
        ServletContextHandler context = new ServletContextHandler(ServletContextHandler.NO_SESSIONS);
        context.setContextPath("/");

        // add servlet for rest-api
        ServletContainer jerseyServlet = new ServletContainer();
        ServletHolder jerseyHolder = new ServletHolder(jerseyServlet);
        jerseyHolder.setInitParameter("jersey.config.server.provider.packages", "de.marstra.dvo.webservice.resources");
        context.addServlet(jerseyHolder, "/api/*");

        // add servlet for static file serving
        DefaultServlet defaultServlet = new DefaultServlet();
        ServletHolder holderPwd = new ServletHolder("default", defaultServlet);

        holderPwd.setInitParameter("resourceBase", "webservice/src/main/webapp");
        // disable directory listing
        context.setInitParameter("org.eclipse.jetty.servlet.Default.dirAllowed", "false");
        context.addServlet(holderPwd, "/*");

        Server jettyServer = new Server(8080);
        jettyServer.setHandler(context);

        try {
            jettyServer.start();
            jettyServer.join();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            jettyServer.destroy();
        }
    }
}
